<?php

/*
* MI Data synchronization package
*/

if( ! defined( 'ABSPATH' ) ) {
    exit;
}

// check if the response includes authorization_code
if (isset($_REQUEST['code']) && $_REQUEST['code'])
{

    $ch = curl_init();
    
    $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/gmail_add_ons/oauth/token';
    
    $mi_pos_authorization_keys_data = get_option('mi_pos_authorization_keys_data');
    $client_id = $mi_pos_authorization_keys_data->client_id;
    $secret_key = $mi_pos_authorization_keys_data->secret_key;
    $redirect_uri = get_admin_url().'admin.php?page=psw-pos';

    $params = array(
        'grant_type' => 'authorization_code',
        'client_id' => $client_id,
        'client_secret' => $secret_key,
        'redirect_uri' => $redirect_uri,
        'code' => $_REQUEST['code']
    );
    
    curl_setopt($ch,CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch,CURLOPT_POST, true);
    curl_setopt($ch,CURLOPT_POSTFIELDS, $params );

    $result = curl_exec($ch);
    curl_close($ch);
    $response = json_decode($result);

    if( isset( $response->access_token ) && ! empty( $response->access_token ) ) {
        $expires_data = date("Y-m-d H:i:s", time() + $response->expires_in);
        $data = array(
            'access_token' => $response->access_token,
            'token_type' => $response->token_type,
            'expires_in' => $response->expires_in,
            'refresh_token' => $response->refresh_token,
            'expires_data' => $expires_data,
        );

        update_option( "mi_psw_pos_auth_details", $data );
        header('Location: '.$redirect_uri.'&success='.urlencode('Authentication Successfully!'));
        exit();
    }
    header('Location: '.$redirect_uri.'&errormsg='.urlencode('Something went to wrong! Authentication Unsuccessfully!'));
    exit();
}else if(isset($_REQUEST['error']) && $_REQUEST['error']){
    $redirect_uri = get_admin_url().'admin.php?page=psw-pos';
    header('Location: '.$redirect_uri.'&errormsg='.urlencode('Something went to wrong! Authentication Unsuccessfully!'));
    exit();
}
