<?php 
/**
 * pos sync product
 *
 */
if( ! class_exists( 'pos_sync_product' ) ) {
    class pos_sync_product{
        
        public function __construct() {
            add_action('wp_ajax_psw_pos_allsyncproduct',array(&$this, 'psw_pos_allsyncproduct'));
		    add_action('wp_ajax_nopriv_psw_pos_allsyncproduct',array(&$this, 'psw_pos_allsyncproduct'));
            add_action('wp_ajax_psw_pos_allsyncorder',array(&$this, 'psw_pos_allsyncorder'));
		    add_action('wp_ajax_nopriv_psw_pos_allsyncorder',array(&$this, 'psw_pos_allsyncorder'));
            add_action('wp_ajax_psw_pos_allsynccustomer',array(&$this, 'psw_pos_allsynccustomer'));
		    add_action('wp_ajax_nopriv_psw_pos_allsynccustomer',array(&$this, 'psw_pos_allsynccustomer'));
            
            add_action('wp_ajax_psw_pos_singlesyncproduct',array(&$this, 'psw_pos_singlesyncproduct'));
		    add_action('wp_ajax_nopriv_psw_pos_singlesyncproduct',array(&$this, 'psw_pos_singlesyncproduct'));
            add_action('wp_ajax_psw_pos_singlesyncorder',array(&$this, 'psw_pos_singlesyncorder'));
		    add_action('wp_ajax_nopriv_psw_pos_singlesyncorder',array(&$this, 'psw_pos_singlesyncorder'));
            add_action('wp_ajax_psw_pos_singlesynccustomer',array(&$this, 'psw_pos_singlesynccustomer'));
		    add_action('wp_ajax_nopriv_psw_pos_singlesynccustomer',array(&$this, 'psw_pos_singlesynccustomer'));
            add_action('wp_ajax_psw_pos_get_sync_count',array(&$this, 'psw_pos_get_sync_count'));
		    add_action('wp_ajax_nopriv_psw_pos_get_sync_count',array(&$this, 'psw_pos_get_sync_count'));

            add_action('wp_ajax_psw_pos_new_sunc_all_in_moon_in',array(&$this, 'psw_pos_new_sunc_all_in_moon_in'));
		    add_action('wp_ajax_nopriv_psw_pos_new_sunc_all_in_moon_in',array(&$this, 'psw_pos_new_sunc_all_in_moon_in'));
            add_action('wp_ajax_psw_pos_new_sunc_single_in_moon_invoice',array(&$this, 'psw_pos_new_sunc_single_in_moon_invoice'));
		    add_action('wp_ajax_nopriv_psw_pos_new_sunc_single_in_moon_invoice',array(&$this, 'psw_pos_new_sunc_single_in_moon_invoice'));

            

            add_action( 'woocommerce_new_product', array(&$this,'pos_sync_on_product_save'), 10, 1 );
            add_action( 'woocommerce_update_product', array(&$this,'pos_sync_on_product_save'), 10, 1 );
            add_action( 'admin_enqueue_scripts', array(&$this,'mi_psw_pos_admin_add_script') );

            add_action('woocommerce_thankyou', array($this,'psw_pos_sync_single_order'), 10, 1);
            add_action('woocommerce_order_status_completed', array($this,'psw_pos_sync_single_order'));

            add_action( 'psw_pos_cron', array($this, 'psw_pos_run_cron'), 10, 2 );
            add_filter( 'cron_schedules', function ( $schedules ) {
                $schedules['permin'] = array(
                    'interval' => 60,
                    'display' => __( 'One Minute' )
                );
                return $schedules;
            } );
        }
        /*
        * Sync Single Product in Moon Invoice
        */

        public function pos_sync_on_product_save( $product_id ) {
            
            $currency = get_option('woocommerce_currency');
            $singlesyncproduct = get_option('psw_pos_singlesyncproduct');
            $WC_Product = wc_get_product( $product_id );
            $psw_pos_singlesync_company = get_option('psw_pos_singlesync_company');
            if($WC_Product->get_type() == 'simple' && $singlesyncproduct['singlesyncproduct_enable'] == 'yes' && $psw_pos_singlesync_company != ''){
                $products['product_records'][0] = $WC_Product->get_data();
                $productid = $WC_Product->get_id();
                $image_id = $WC_Product->get_image_id();

                $products['currency']= $currency;
                $image_url = wp_get_attachment_image_src( $image_id, 'full' );
                
                $products['product_records'][0]['image_url'] = $image_url[0];
                
                $products['company']= $psw_pos_singlesync_company;
                
                $products['pos_data_type']= 'single';
                
                $params = json_encode($products, JSON_FORCE_OBJECT);

                $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
                $access_token = $mi_psw_pos_auth_details['access_token'];
                $token_type = $mi_psw_pos_auth_details['token_type'];
                $psw_pos_access_token = $token_type.' '.$access_token;

                $ch = curl_init();
                $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_product';
                $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

                curl_setopt($ch,CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch,CURLOPT_POST, true);
                curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                $result = curl_exec($ch);
                curl_close($ch);
                $response = json_decode($result);
            }
        }
        /*
        * Sync Single Order in Moon Invoice
        * Sync Single Customer in Moon Invoice
        */
        public function psw_pos_sync_single_order($order_id){
            global $wpdb;
            if ( ! $order_id )
                return;
            $date = date('d-m-Y H:i', strtotime("+1 min"));
            $times = strtotime($date);
            //$plustime = date(strtotime("+1 min"));
            if ( ! wp_next_scheduled( 'psw_pos_cron' ) ) {
                wp_schedule_event(strtotime( '+1 min' ), 'permin', 'psw_pos_cron',array($order_id) );                
            }
        }
        /*
        * Sync crone Single Order in Moon Invoice
        * Sync crone Single Customer in Moon Invoice
        */
        function psw_pos_run_cron($order_id){
            global $wpdb;
            $singlesyncorder = get_option('psw_pos_singlesyncorder');
            $currency = get_option('woocommerce_currency');
            // Allow code execution only once 
            $psw_pos_singlesync_company = get_option('psw_pos_singlesync_company');
            if(isset($singlesyncorder['singlesyncorder_enable'])){
                if( ! get_post_meta( $order_id, '_thankyou_action_done', true ) && $singlesyncorder['singlesyncorder_enable'] == 'yes') {
                    $ordernd = wc_get_order( $order_id );
                    $response = $ordernd->get_data();
                    $n=0;
                    foreach ( $ordernd->get_items() as $item_id => $item ) {
                        $line_items_nd[$n]['data'] = $item->get_data();
                        $product_id = $item->get_product_id();                        
                        $WC_Product = wc_get_product( $product_id );
                        $line_items_nd[$n]['data']['product_records'][0] = $WC_Product->get_data();
                        $productid = $WC_Product->get_id();
                        $image_id = $WC_Product->get_image_id();
                        $products['currency']= $currency;
                        $image_url = wp_get_attachment_image_src( $image_id, 'full' );
                        $line_items_nd[$n]['data']['product_records'][0]['image_url'] = $image_url[0];
                        $n++;
                    }

                    $coupon_items =array();
                    foreach ($ordernd->get_items('coupon') as $kkk => $coupon_item) {
                        $coupon = new WC_Coupon($coupon_item['name']);
                        $coupon_items['data'] = $coupon->get_data();
                    }
                    $tax_lines = array();
                    foreach ($ordernd->get_tax_totals() as $tax_code => $tax) {  
                        $taxper = WC_Tax::get_rate_percent( $tax->rate_id );
                        $tax->tax_percent = str_replace('%', '', $taxper);
                        $tax_lines['data'] = $tax;
                    }
                    $fee_total = 0;
                    $fee_tax_total = 0;
                    $fee_items = array('');
                    foreach ($ordernd->get_fees() as $fee_id => $fee) {

                        $fee_items['data'] = array(
                                'name:' .  html_entity_decode($fee['name'], ENT_NOQUOTES, 'UTF-8'),
                                'total:' . wc_format_decimal($fee['line_total'], 2),
                                'tax:' . wc_format_decimal($fee['line_tax'], 2),
                        );

                        $fee_total += $fee['line_total'];
                        $fee_tax_total += $fee['line_tax'];
                    }
                    $line_items_shipping = $ordernd->get_items('shipping');
                    foreach ($line_items_shipping as $item_id => $item) {
                        if (is_object($item)) {
                            if ($meta_data = $item->get_formatted_meta_data('')) :
                                foreach ($meta_data as $meta_id => $meta) :
                                    if (in_array($meta->key, $line_items_shipping)) {
                                        continue;
                                    }
                                    $shipping_items['data'] = array('item:' . wp_kses_post($meta->display_key), 'value:' . str_replace('&times;', 'X', strip_tags($meta->display_value)));
                                endforeach;
                            endif;
                        }
                    }
                    $passorder['order_records'][0]=$response;
                    $passorder['pos_data_type']= 'single';
                    $passorder['company']= $psw_pos_singlesync_company;
                    $passorder['currency']= $currency;
                    $table = $wpdb->prefix.'wc_order_stats';
                    $tablecst = $wpdb->prefix.'wc_customer_lookup';
                    $customerdata1 = $wpdb->get_results('SELECT '.$tablecst.'.customer_id, '.$tablecst.'.user_id, '.$tablecst.'.username, '.$tablecst.'.first_name, '.$tablecst.'.last_name, '.$tablecst.'.email, '.$tablecst.'.country, '.$tablecst.'.postcode, '.$tablecst.'.city, '.$tablecst.'.state, '.$tablecst.'.date_last_active, '.$tablecst.'.date_registered FROM '.$tablecst.' LEFT JOIN '.$table.' ON '.$tablecst.'.customer_id = '.$table.'.customer_id WHERE '.$table.'.order_id ='.$order_id);
                    
                    $passorder['order_records'][0]['customer_records'] = $customerdata1[0];
                    $passorder['order_records'][0]['line_items']=$line_items_nd;
                    $passorder['order_records'][0]['coupon_lines']=$coupon_items;
                    $passorder['order_records'][0]['tax_lines']=$tax_lines;
                    $passorder['order_records'][0]['fee_lines']=$fee_items;
                    $passorder['order_records'][0]['shipping_lines']=$shipping_items;

                    $params = json_encode($passorder);
                    $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
                    $access_token = $mi_psw_pos_auth_details['access_token'];
                    $token_type = $mi_psw_pos_auth_details['token_type'];
                    $psw_pos_access_token = $token_type.' '.$access_token;

                    $ch = curl_init();
                    $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_invoice';
                    $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

                    curl_setopt($ch,CURLOPT_URL, $url);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    curl_setopt($ch,CURLOPT_POST, true);
                    curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
                    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                    $result = curl_exec($ch);
                    curl_close($ch);
                    $response = json_decode($result);
                }
            }
            $singlesynccustomer = get_option('psw_pos_singlesynccustomer');
            if(isset($singlesynccustomer['singlesynccustomer_enable'])){
                if( ! get_post_meta( $order_id, '_thankyou_action_done', true ) && $singlesynccustomer['singlesynccustomer_enable'] == 'yes') {
                    
                    $table = $wpdb->prefix.'wc_order_stats';
                    $tablecst = $wpdb->prefix.'wc_customer_lookup';
                    $customerdata = $wpdb->get_results('SELECT '.$tablecst.'.customer_id, '.$tablecst.'.user_id, '.$tablecst.'.username, '.$tablecst.'.first_name, '.$tablecst.'.last_name, '.$tablecst.'.email, '.$tablecst.'.country, '.$tablecst.'.postcode, '.$tablecst.'.city, '.$tablecst.'.state, '.$tablecst.'.date_last_active, '.$tablecst.'.date_registered FROM '.$tablecst.' LEFT JOIN '.$table.' ON '.$tablecst.'.customer_id = '.$table.'.customer_id WHERE '.$table.'.order_id ='.$order_id);

                    $customer_rec['customer_records'] = $customerdata;
                    $customer_rec['pos_data_type']= 'single';
                    $customer_rec['company']= $psw_pos_singlesync_company;
                    $customer_rec['currency']= $currency;
                    $params = json_encode($customer_rec, JSON_FORCE_OBJECT);
                    
                    $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
                    $access_token = $mi_psw_pos_auth_details['access_token'];
                    $token_type = $mi_psw_pos_auth_details['token_type'];
                    $psw_pos_access_token = $token_type.' '.$access_token;

                    $ch = curl_init();
                    $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_customer';
                    $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

                    curl_setopt($ch,CURLOPT_URL, $url);
                    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                    curl_setopt($ch,CURLOPT_POST, true);
                    curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
                    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                    $result = curl_exec($ch);
                    curl_close($ch);
                    $response = json_decode($result);
                }
            }
            wp_clear_scheduled_hook( 'psw_pos_cron','' );
            wp_unschedule_hook('psw_pos_cron');
            return;
        }
        /*
        *  Add css and js in Admin 
        */
        public function mi_psw_pos_admin_add_script(){
            wp_enqueue_style( 'mi-psw-pos-css');
            wp_enqueue_script( 'mi-psw-pos-script');
            wp_enqueue_script( 'mi-psw-pos-script-handle', WP_MI_PSW_POS_PLUGIN_URL . '/assets/admin/js/mi-psw-pos-admin.js', '', '' );
            wp_enqueue_style('mi-psw-pos-css-handle',WP_MI_PSW_POS_PLUGIN_URL . '/assets/admin/css/mi-psw-pos-admin.css' );

            wp_enqueue_style('mi-psw-pos-select-css-handle','https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css' );
            wp_enqueue_script( 'mi-psw-pos-select-js-handle', 'https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js', '', '' );
        }
        /*
        * Sync Count get
        */
        public function psw_pos_get_sync_count(){
            $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
            $access_token = $mi_psw_pos_auth_details['access_token'];
            $token_type = $mi_psw_pos_auth_details['token_type'];
            $psw_pos_access_token = $token_type.' '.$access_token;

            $ch = curl_init();
            $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/total_sync';
            $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

            curl_setopt($ch,CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch,CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result_pos = curl_exec($ch);
            curl_close($ch);
            $response_pos = json_decode($result_pos);
            $res_data = $response_pos->data;
            $total_product = $res_data->total_product;
            $total_invoice = $res_data->total_invoice;
            $total_customer = $res_data->total_customer;
            ?>
                <div class="psw-pos-product-sync-count">
                    <label>Total Sync Product</label>
                    <span><?php echo $total_product; ?></span>
                </div>
                <div class="psw-pos-order-sync-count">
                    <label>Total Sync Order</label>
                    <span><?php echo $total_invoice; ?></span>
                </div>
                <div class="psw-pos-customer-sync-count">
                    <label>Total Sync Customer</label>
                    <span><?php echo $total_customer; ?></span>
                </div>
            <?php
            exit();
        }
        /*
        * Sync all Product in Moon Invoice
        */
        public function psw_pos_allsyncproduct(){
            if($_POST['allsyncproduct_enable'] == 'yes'){
                $allsyncproduct_enable = $_POST['allsyncproduct_enable'];
                $allsyncproduct_company = $_POST['allsyncproduct_company'];
                $allsyncproduct = array('allsyncproduct_enable'=>$allsyncproduct_enable,'allsyncproduct_company'=>$allsyncproduct_company);
                update_option('psw_pos_allsyncproduct',$allsyncproduct);
                
                $currency = get_option('woocommerce_currency');
                $args = array(
                    'type' => 'simple',
                );

                $products['currency']= $currency;
                $products['company']= array($_POST['allsyncproduct_company']);
                $products['pos_data_type']= 'all';
                $products['product_records'] = wc_get_products( $args );
                $n=0;
                $datafull = wc_get_products( $args );
                foreach($datafull as $productsmn){
                    $productid = $productsmn->get_id();
                    $image_url = wp_get_attachment_image_src( get_post_thumbnail_id( $productid ), 'full' );
                    $products['product_records'][$n] =$productsmn->get_data();
                    $products['product_records'][$n]['image_url'] = $image_url[0];
                    $n++;
                }


                $params = json_encode($products, JSON_FORCE_OBJECT);
                
                $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
                $access_token = $mi_psw_pos_auth_details['access_token'];
                $token_type = $mi_psw_pos_auth_details['token_type'];
                $psw_pos_access_token = $token_type.' '.$access_token;

                $ch = curl_init();
                $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_product';
                $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

                curl_setopt($ch,CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch,CURLOPT_POST, true);
                curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                $result = curl_exec($ch);
                curl_close($ch);
                $response = json_decode($result);
                if($response->status ==200){
                    echo json_encode(array('status'=>true,'message'=>$response->message));
                }else{
                    echo json_encode(array('status'=>false,'message'=>$response->message));
                }
            }else{
                update_option('psw_pos_allsyncproduct','');
                echo json_encode(array('status'=>true,'message'=>'Products Sync Desable Successfully.'));
            }
            exit();
        }
        /*
        * Sync all Order in Moon Invoice
        */
        public function psw_pos_allsyncorder(){
            global $wpdb;
            if($_POST['allsyncorder_enable'] == 'yes'){
                $allsyncorder_enable = $_POST['allsyncorder_enable'];
                $allsyncorder_company = $_POST['allsyncorder_company'];
                $allsyncorder = array('allsyncorder_enable'=>$allsyncorder_enable,'allsyncorder_company'=>$allsyncorder_company);
                update_option('psw_pos_allsyncorder',$allsyncorder);
                
                $args = array('post_type'=>'shop_order','post_status'=>'wc-completed','posts_per_page' => -1);
                $my_query = new WP_Query($args);
                
                $ordersqry = $my_query->posts;
                $passorder = array();
                $key = 0; 
                foreach($ordersqry as $orderinr){
                    
                    $order_id = $orderinr->ID;
                    
                    $ordernd = wc_get_order( $order_id );
                    $response = $ordernd->get_data();
                    
                    $passorder['order_records'][$key]=$response;
                    $table = $wpdb->prefix.'wc_order_stats';
                    $tablecst = $wpdb->prefix.'wc_customer_lookup';
                    $customerdata = $wpdb->get_results('SELECT '.$tablecst.'.customer_id, '.$tablecst.'.user_id, '.$tablecst.'.username, '.$tablecst.'.first_name, '.$tablecst.'.last_name, '.$tablecst.'.email, '.$tablecst.'.country, '.$tablecst.'.postcode, '.$tablecst.'.city, '.$tablecst.'.state, '.$tablecst.'.date_last_active, '.$tablecst.'.date_registered FROM '.$tablecst.' LEFT JOIN '.$table.' ON '.$tablecst.'.customer_id = '.$table.'.customer_id WHERE '.$table.'.order_id ='.$order_id);
                    
                    $passorder['order_records'][$key]['customer_records'] = $customerdata[0];
                    $n=0;
                    $line_items_nd =array();
                    foreach ( $ordernd->get_items() as $item_id => $item ) {
                        $line_items_nd[$n]['data'] = $item->get_data();
                        $product_id = $item->get_product_id();
                    
                        $WC_Product = wc_get_product( $product_id );
                        
                        $line_items_nd[$n]['data']['product_records'][0] = $WC_Product->get_data();
                        $productid = $WC_Product->get_id();
                        $image_id = $WC_Product->get_image_id();

                        $products['currency']= $currency;
                        $image_url = wp_get_attachment_image_src( $image_id, 'full' );
                        $line_items_nd[$n]['data']['product_records'][0]['image_url'] = $image_url[0];
                        $n++;
                    }
                    $passorder['order_records'][$key]['line_items']=$line_items_nd;
                    
                    $coupon_items =array();
                    foreach ($ordernd->get_items('coupon') as $kkk => $coupon_item) {
                        
                        $coupon = new WC_Coupon($coupon_item['name']);
                        $coupon_items['data'] = $coupon->get_data();
                    }
                    $passorder['order_records'][$key]['coupon_lines']=$coupon_items;
                    // get tax items
                    $tax = $ordernd->get_taxes();
                    
                    $tax_lines = array();
                    foreach ($ordernd->get_tax_totals() as $tax_code => $tax) {  
                            $taxper = WC_Tax::get_rate_percent( $tax->rate_id );
                            $tax->tax_percent = str_replace('%', '', $taxper);
                            $tax_lines['data'] = $tax;
                    }
                    $passorder['order_records'][$key]['tax_lines']=$tax_lines;

                    $fee_total = 0;
                    $fee_tax_total = 0;
                    $fee_items = array('');
                    foreach ($ordernd->get_fees() as $fee_id => $fee) {
                        $fee_items['data'] = array(
                                'name:' .  html_entity_decode($fee['name'], ENT_NOQUOTES, 'UTF-8'),
                                'total:' . wc_format_decimal($fee['line_total'], 2),
                                'tax:' . wc_format_decimal($fee['line_tax'], 2),
                        );
                        $fee_total += $fee['line_total'];
                        $fee_tax_total += $fee['line_tax'];
                    }
                    $passorder['order_records'][$key]['fee_lines']=$fee_items;

                    $line_items_shipping = $ordernd->get_items('shipping');
                    foreach ($line_items_shipping as $item_id => $item) {
                        if (is_object($item)) {
                            if ($meta_data = $item->get_formatted_meta_data('')) :
                                foreach ($meta_data as $meta_id => $meta) :
                                    if (in_array($meta->key, $line_items_shipping)) {
                                        continue;
                                    }
                                    // html entity decode is not working preoperly
                                    $shipping_items['data'] = array('item:' . wp_kses_post($meta->display_key), 'value:' . str_replace('&times;', 'X', strip_tags($meta->display_value)));
                                endforeach;
                            endif;
                        }
                    }
                    $passorder['order_records'][$key]['shipping_lines']=$shipping_items;
                    $key++;
                    
                }
                $passorder['pos_data_type']= 'all';
                $passorder['company']= array($_POST['allsyncorder_company']);
                $params = json_encode($passorder, JSON_FORCE_OBJECT);
                
                $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
                $access_token = $mi_psw_pos_auth_details['access_token'];
                $token_type = $mi_psw_pos_auth_details['token_type'];
                $psw_pos_access_token = $token_type.' '.$access_token;

                $ch = curl_init();
                $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_invoice';
                $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

                curl_setopt($ch,CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch,CURLOPT_POST, true);
                curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                $result = curl_exec($ch);
                curl_close($ch);
                $response = json_decode($result);
                if($response->status ==200){
                    echo json_encode(array('status'=>true,'message'=>$response->message));
                }else{
                    echo json_encode(array('status'=>false,'message'=>$response->message));
                }
            }else{
                update_option('psw_pos_allsyncorder','');
                echo json_encode(array('status'=>true,'message'=>'Products Sync Desable Successfully.'));
            }
            exit();
        }
        /*
        * Sync all Customer in Moon Invoice
        */
        public function psw_pos_allsynccustomer(){
            global $wpdb;
            $currency = get_option('woocommerce_currency');
            if($_POST['allsynccustomer_enable'] == 'yes'){
                $allsynccustomer_enable = $_POST['allsynccustomer_enable'];
                $allsynccustomer_company = $_POST['allsynccustomer_company'];
                $allsyncustomer = array('allsynccustomer_enable'=>$allsynccustomer_enable,'allsynccustomer_company'=>$allsynccustomer_company);
                update_option('psw_pos_allsynccustomer',$allsyncustomer);
                
                $table = $wpdb->prefix.'wc_customer_lookup';
                $customer_rec['customer_records'] = $wpdb->get_results('SELECT * FROM '.$table);

                $customer_rec['pos_data_type']= 'all';
                $customer_rec['company']= array($_POST['allsynccustomer_company']);
                $customer_rec['currency']= $currency;
                $params = json_encode($customer_rec, JSON_FORCE_OBJECT);
                
                $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
                $access_token = $mi_psw_pos_auth_details['access_token'];
                $token_type = $mi_psw_pos_auth_details['token_type'];
                $psw_pos_access_token = $token_type.' '.$access_token;

                $ch = curl_init();
                $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_customer';
                $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

                curl_setopt($ch,CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch,CURLOPT_POST, true);
                curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
                curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
                $result = curl_exec($ch);
                curl_close($ch);
                $response = json_decode($result);
                if($response->status ==200){
                    echo json_encode(array('status'=>true,'message'=>$response->message));
                }else{
                    echo json_encode(array('status'=>false,'message'=>$response->message));
                }
            }else{
                update_option('psw_pos_allsynccustomer','');
                echo json_encode(array('status'=>true,'message'=>'Customer Sync Desable Successfully.'));
            }
            exit();
        }
        /*
        * Sync Single Product in Moon Invoice
        */
        public function psw_pos_singlesyncproduct(){
            if($_POST['singlesyncproduct_enable'] == 'yes'){
                $singlesyncproduct_enable = $_POST['singlesyncproduct_enable'];
                $singlesyncproduct_company = $_POST['singlesyncproduct_company'];
                $singlesyncproduct = array('singlesyncproduct_enable'=>$singlesyncproduct_enable,'singlesyncproduct_company'=>$singlesyncproduct_company);
                update_option('psw_pos_singlesyncproduct',$singlesyncproduct);
                
                echo json_encode(array('status'=>false,'message'=>'Products Sync Enable Successfully'));

            }else{
                update_option('psw_pos_singlesyncproduct','');
                echo json_encode(array('status'=>true,'message'=>'Products Sync Desable Successfully.'));
            }
            exit();
        }
        /*
        * Sync all Order in Moon Invoice
        */
        public function psw_pos_singlesyncorder(){
            
            if($_POST['singlesyncorder_enable'] == 'yes'){
                $singlesyncorder_enable = $_POST['singlesyncorder_enable'];
                $singlesyncorder_company = $_POST['singlesyncorder_company'];
                $singlesyncorder = array('singlesyncorder_enable'=>$singlesyncorder_enable,'singlesyncorder_company'=>$singlesyncorder_company);
                update_option('psw_pos_singlesyncorder',$singlesyncorder);
                echo json_encode(array('status'=>false,'message'=>'Order Sync Enable Successfully.'));
            }else{
                update_option('psw_pos_singlesyncorder','');
                echo json_encode(array('status'=>true,'message'=>'Order Sync Desable Successfully.'));
            }
            exit();
        }
        /*
        * Sync Single Customer in Moon Invoice
        */
        public function psw_pos_singlesynccustomer(){
            if($_POST['singlesynccustomer_enable'] == 'yes'){
                $singlesynccustomer_enable = $_POST['singlesynccustomer_enable'];
                $singlesynccustomer_company = $_POST['singlesynccustomer_company'];
                $singlesyncustomer = array('singlesynccustomer_enable'=>$singlesynccustomer_enable,'singlesynccustomer_company'=>$singlesynccustomer_company);
                update_option('psw_pos_singlesynccustomer',$singlesyncustomer);
                echo json_encode(array('status'=>false,'message'=>'Customer Sync Enable Successfully'));
            }else{
                update_option('psw_pos_singlesynccustomer','');
                echo json_encode(array('status'=>true,'message'=>'Customer Sync Desable Successfully.'));
            }
            exit();
        }
        /*
        * psw_pos_new_sunc_all_in_moon_in
        */
        public function psw_pos_new_sunc_all_in_moon_in(){
            $enableof = $_POST['enableof'];
            $company = $_POST['company'];
            if(isset($company)){
                update_option('psw_pos_singlesync_company',$company);
            }else{
                update_option('psw_pos_singlesync_company','');
            }
            if(in_array('products',$enableof)){
                $products_res = $this->psw_pos_allsync_products($company);
            }else{
                update_option('psw_pos_allsyncproduct','');
                $products_res = json_encode(array('status'=>true,'message'=>'Products Sync Desable Successfully.'));
            }
            if(in_array('orders',$enableof)){
                $orders_res = $this->psw_pos_allsync_orders($company);
            }else{
                update_option('psw_pos_allsyncorder','');
                $orders_res = json_encode(array('status'=>true,'message'=>'Products Sync Desable Successfully.'));
            }
            if(in_array('customers',$enableof)){
                $customers_res = $this->psw_pos_allsync_customers($company);
            }else{
                update_option('psw_pos_allsynccustomer','');
                $customers_res = json_encode(array('status'=>true,'message'=>'Customer Sync Desable Successfully.'));
            }

            echo json_encode(array('status'=>true,'message'=>'Data sync Successfully'));
            exit();
        }

        /*
        * Sync all Product in Moon Invoice
        */
        public function psw_pos_allsync_products($company){
            $allsyncproduct_enable = 'yes';
            $allsyncproduct_company = $company;
            $allsyncproduct = array('allsyncproduct_enable'=>$allsyncproduct_enable,'allsyncproduct_company'=>$allsyncproduct_company);
            update_option('psw_pos_allsyncproduct',$allsyncproduct);
            
            $currency = get_option('woocommerce_currency');
            $args = array(
                'type' => 'simple',
                'posts_per_page'=>-1
            );

            $products['currency']= $currency;
            $products['company']= $company;
            $products['pos_data_type']= 'all';
            $products['product_records'] = wc_get_products( $args );
            $n=0;
            $datafull = wc_get_products( $args );
            foreach($datafull as $productsmn){
                $productid = $productsmn->get_id();
                $image_url = wp_get_attachment_image_src( get_post_thumbnail_id( $productid ), 'full' );
                $products['product_records'][$n] =$productsmn->get_data();
                $products['product_records'][$n]['image_url'] = $image_url[0];
                $n++;
            }
            
            $params = json_encode($products, JSON_FORCE_OBJECT);
            
            $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
            $access_token = $mi_psw_pos_auth_details['access_token'];
            $token_type = $mi_psw_pos_auth_details['token_type'];
            $psw_pos_access_token = $token_type.' '.$access_token;

            $ch = curl_init();
            $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_product';
            $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

            curl_setopt($ch,CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch,CURLOPT_POST, true);
            curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);
            curl_close($ch);
            $response = json_decode($result);
            if($response->status ==200){
                $return = json_encode(array('status'=>true,'message'=>$response->message));
            }else{
                $return = json_encode(array('status'=>false,'message'=>$response->message));
            }
            return $return;
            die();
        }
        /*
        * Sync all Orders in Moon Invoice
        */
        public function psw_pos_allsync_orders($company){
            global $wpdb;
            $allsyncorder_enable = 'yes';
            $allsyncorder_company = $company;
            $allsyncorder = array('allsyncorder_enable'=>$allsyncorder_enable,'allsyncorder_company'=>$allsyncorder_company);
            update_option('psw_pos_allsyncorder',$allsyncorder);
            
            $args = array('post_type'=>'shop_order','post_status'=>'wc-completed','posts_per_page' => -1);
            $my_query = new WP_Query($args);
            
            $ordersqry = $my_query->posts;
            $passorder = array();
            $key = 0; 
            foreach($ordersqry as $orderinr){
                
                $order_id = $orderinr->ID;
                
                $ordernd = wc_get_order( $order_id );
                $response = $ordernd->get_data();
                
                $passorder['order_records'][$key]=$response;
                $table = $wpdb->prefix.'wc_order_stats';
                $tablecst = $wpdb->prefix.'wc_customer_lookup';
                $customerdata = $wpdb->get_results('SELECT '.$tablecst.'.customer_id, '.$tablecst.'.user_id, '.$tablecst.'.username, '.$tablecst.'.first_name, '.$tablecst.'.last_name, '.$tablecst.'.email, '.$tablecst.'.country, '.$tablecst.'.postcode, '.$tablecst.'.city, '.$tablecst.'.state, '.$tablecst.'.date_last_active, '.$tablecst.'.date_registered FROM '.$tablecst.' LEFT JOIN '.$table.' ON '.$tablecst.'.customer_id = '.$table.'.customer_id WHERE '.$table.'.order_id ='.$order_id);
                
                $passorder['order_records'][$key]['customer_records'] = $customerdata[0];
                $n=0;
                $line_items_nd =array();
                foreach ( $ordernd->get_items() as $item_id => $item ) {
                    $line_items_nd[$n]['data'] = $item->get_data();
                    $product_id = $item->get_product_id();
                
                    $WC_Product = wc_get_product( $product_id );
                    
                    $line_items_nd[$n]['data']['product_records'][0] = $WC_Product->get_data();
                    $productid = $WC_Product->get_id();
                    $image_id = $WC_Product->get_image_id();

                    $products['currency']= $currency;
                    $image_url = wp_get_attachment_image_src( $image_id, 'full' );
                    $line_items_nd[$n]['data']['product_records'][0]['image_url'] = $image_url[0];
                    $n++;
                }
                $passorder['order_records'][$key]['line_items']=$line_items_nd;
                
                $coupon_items =array();
                foreach ($ordernd->get_items('coupon') as $kkk => $coupon_item) {
                    
                    $coupon = new WC_Coupon($coupon_item['name']);
                    $coupon_items['data'] = $coupon->get_data();
                }
                $passorder['order_records'][$key]['coupon_lines']=$coupon_items;
                // get tax items
                $tax = $ordernd->get_taxes();
                
                $tax_lines = array();
                foreach ($ordernd->get_tax_totals() as $tax_code => $tax) {  
                        $taxper = WC_Tax::get_rate_percent( $tax->rate_id );
                        $tax->tax_percent = str_replace('%', '', $taxper);
                        $tax_lines['data'] = $tax;
                }
                $passorder['order_records'][$key]['tax_lines']=$tax_lines;

                $fee_total = 0;
                $fee_tax_total = 0;
                $fee_items = array('');
                foreach ($ordernd->get_fees() as $fee_id => $fee) {
                    $fee_items['data'] = array(
                            'name:' .  html_entity_decode($fee['name'], ENT_NOQUOTES, 'UTF-8'),
                            'total:' . wc_format_decimal($fee['line_total'], 2),
                            'tax:' . wc_format_decimal($fee['line_tax'], 2),
                    );
                    $fee_total += $fee['line_total'];
                    $fee_tax_total += $fee['line_tax'];
                }
                $passorder['order_records'][$key]['fee_lines']=$fee_items;

                $line_items_shipping = $ordernd->get_items('shipping');
                foreach ($line_items_shipping as $item_id => $item) {
                    if (is_object($item)) {
                        if ($meta_data = $item->get_formatted_meta_data('')) :
                            foreach ($meta_data as $meta_id => $meta) :
                                if (in_array($meta->key, $line_items_shipping)) {
                                    continue;
                                }
                                // html entity decode is not working preoperly
                                $shipping_items['data'] = array('item:' . wp_kses_post($meta->display_key), 'value:' . str_replace('&times;', 'X', strip_tags($meta->display_value)));
                            endforeach;
                        endif;
                    }
                }
                $passorder['order_records'][$key]['shipping_lines']=$shipping_items;
                $key++;
                
            }
            $passorder['pos_data_type']= 'all';
            $passorder['company']= $company;
            $params = json_encode($passorder, JSON_FORCE_OBJECT);
            
            $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
            $access_token = $mi_psw_pos_auth_details['access_token'];
            $token_type = $mi_psw_pos_auth_details['token_type'];
            $psw_pos_access_token = $token_type.' '.$access_token;

            $ch = curl_init();
            $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_invoice';
            $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

            curl_setopt($ch,CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch,CURLOPT_POST, true);
            curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);
            curl_close($ch);
            $response = json_decode($result);
            if($response->status ==200){
                $return = json_encode(array('status'=>true,'message'=>$response->message));
            }else{
                $return = json_encode(array('status'=>false,'message'=>$response->message));
            }
            return $return;
        }
        /*
        * Sync all Customers in Moon Invoice
        */
        public function psw_pos_allsync_customers($company){
            global $wpdb;
            $currency = get_option('woocommerce_currency');
            $allsynccustomer_enable = 'yes';
            $allsynccustomer_company = $company;
            $allsyncustomer = array('allsynccustomer_enable'=>$allsynccustomer_enable,'allsynccustomer_company'=>$allsynccustomer_company);
            update_option('psw_pos_allsynccustomer',$allsyncustomer);
            
            $table = $wpdb->prefix.'wc_customer_lookup';
            $customer_rec['customer_records'] = $wpdb->get_results('SELECT * FROM '.$table);

            $customer_rec['pos_data_type']= 'all';
            $customer_rec['company']= $company;
            $customer_rec['currency']= $currency;
            $params = json_encode($customer_rec, JSON_FORCE_OBJECT);
            
            $mi_psw_pos_auth_details = get_option('mi_psw_pos_auth_details');
            $access_token = $mi_psw_pos_auth_details['access_token'];
            $token_type = $mi_psw_pos_auth_details['token_type'];
            $psw_pos_access_token = $token_type.' '.$access_token;

            $ch = curl_init();
            $url = WP_MI_PSW_POS_PLUGIN_API_ENDPOINT.'/woocommerce/create_customer';
            $headers = array('Content-Type: application/json', 'Authorization: '.$psw_pos_access_token);

            curl_setopt($ch,CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch,CURLOPT_POST, true);
            curl_setopt($ch,CURLOPT_POSTFIELDS, $params );
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
            $result = curl_exec($ch);
            curl_close($ch);
            $response = json_decode($result);
            if($response->status ==200){
                $return = json_encode(array('status'=>true,'message'=>$response->message));
            }else{
                $return = json_encode(array('status'=>false,'message'=>$response->message));
            }
            return $return;
        }
        /*
        * Sync enable in single 
        */
        public function psw_pos_new_sunc_single_in_moon_invoice(){

            $company = $_POST['company'];
            $enableof = $_POST['enableof'];
            if(isset($company)){
                update_option('psw_pos_singlesync_company',$company);
            }else{
                update_option('psw_pos_singlesync_company','');
            }
            if($_POST['syncenable'] == 'yes'){
                update_option('psw_pos_autosync_enable','yes');
                /* Product */
                $singlesyncproduct_enable = 'yes';
                $singlesyncproduct_company = $company;
                $singlesyncproduct = array('singlesyncproduct_enable'=>$singlesyncproduct_enable,'singlesyncproduct_company'=>$singlesyncproduct_company);
                update_option('psw_pos_singlesyncproduct',$singlesyncproduct);
                $product_res = json_encode(array('status'=>false,'message'=>'Products Sync Enable Successfully'));

                /* Order */
                $singlesyncorder_enable = 'yes';
                $singlesyncorder_company = $company;
                $singlesyncorder = array('singlesyncorder_enable'=>$singlesyncorder_enable,'singlesyncorder_company'=>$singlesyncorder_company);
                update_option('psw_pos_singlesyncorder',$singlesyncorder);
                $order_res = json_encode(array('status'=>false,'message'=>'Order Sync Enable Successfully.'));
                
                /* Customer */
                $singlesynccustomer_enable = 'yes';
                $singlesynccustomer_company = $company;
                $singlesyncustomer = array('singlesynccustomer_enable'=>$singlesynccustomer_enable,'singlesynccustomer_company'=>$singlesynccustomer_company);
                update_option('psw_pos_singlesynccustomer',$singlesyncustomer);
                $order_res = json_encode(array('status'=>false,'message'=>'Customer Sync Enable Successfully'));
            }else{
                update_option('psw_pos_singlesyncproduct','');
                update_option('psw_pos_singlesyncorder','');
                update_option('psw_pos_singlesynccustomer','');
                update_option('psw_pos_autosync_enable','');
                $order_res = json_encode(array('status'=>true,'message'=>'Customer Sync Desable Successfully.'));
            }
            /**************************************************************/
            /* if(in_array('products',$enableof)){
                $singlesyncproduct_enable = 'yes';
                $singlesyncproduct_company = $company;
                $singlesyncproduct = array('singlesyncproduct_enable'=>$singlesyncproduct_enable,'singlesyncproduct_company'=>$singlesyncproduct_company);
                update_option('psw_pos_singlesyncproduct',$singlesyncproduct);
                $product_res = json_encode(array('status'=>false,'message'=>'Products Sync Enable Successfully'));
    
            }else{
                update_option('psw_pos_singlesyncproduct','');
                $product_res = json_encode(array('status'=>true,'message'=>'Products Sync Desable Successfully.'));
            }

            if(in_array('orders',$enableof)){
                $singlesyncorder_enable = 'yes';
                $singlesyncorder_company = $company;
                $singlesyncorder = array('singlesyncorder_enable'=>$singlesyncorder_enable,'singlesyncorder_company'=>$singlesyncorder_company);
                update_option('psw_pos_singlesyncorder',$singlesyncorder);
                $order_res = json_encode(array('status'=>false,'message'=>'Order Sync Enable Successfully.'));
            }else{
                update_option('psw_pos_singlesyncorder','');
                $order_res = json_encode(array('status'=>true,'message'=>'Order Sync Desable Successfully.'));
            }

            if(in_array('customers',$enableof)){
                $singlesynccustomer_enable = 'yes';
                $singlesynccustomer_company = $company;
                $singlesyncustomer = array('singlesynccustomer_enable'=>$singlesynccustomer_enable,'singlesynccustomer_company'=>$singlesynccustomer_company);
                update_option('psw_pos_singlesynccustomer',$singlesyncustomer);
                $order_res = json_encode(array('status'=>false,'message'=>'Customer Sync Enable Successfully'));
            }else{
                update_option('psw_pos_singlesynccustomer','');
                $order_res = json_encode(array('status'=>true,'message'=>'Customer Sync Desable Successfully.'));
            } */
            echo json_encode(array('status'=>true,'message'=>'Changes Apply Successfully'));
            die();
        }
    }
    new pos_sync_product();
}