<?php
/**
 * @since             1.0.0
 * @package           products_sync_with_pos_moon_invoice
 *
 * @wordpress-plugin
 * Plugin Name: Products Sync with Moon Invoice
 * Plugin URI:        https://www.mooninvoice.com/
 * Description:       Handle the basics with this plugin.
 * Version:           1.2.0
 * Requires at least: 5.6.1
 * Tested up to: 5.6.1
 * Requires PHP:      7.0
 * Author:            Moon Invoice
 * Author URI:        https://www.mooninvoice.com/
 * License:           GPL v2 or later
 * License URI:       https://www.gnu.org/licenses/gpl-2.0.html
 * Update URI:        https://www.mooninvoice.com/integrations/
 * Text Domain:       products-sync-with-pos-moon-invoice
 */
if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die('You are not allowed to call this page directly.'); }

if ( ! defined( 'WP_MI_PSW_POS_BASENAME' ) )
	define( 'WP_MI_PSW_POS_BASENAME', plugin_basename( __FILE__ ) );

if ( ! defined( 'WP_MI_PSW_POS_PLUGIN_PATH' ) )
	define( 'WP_MI_PSW_POS_PLUGIN_PATH', plugin_dir_path( __FILE__ ) );
	
if ( ! defined( 'WP_MI_PSW_POS_PLUGIN_NAME' ) )
	define( 'WP_MI_PSW_POS_PLUGIN_NAME', trim( dirname( WP_MI_PSW_POS_BASENAME ), '/' ) );
	
if ( ! defined( 'WP_MI_PSW_POS_PLUGIN_URL' ) )
	define( 'WP_MI_PSW_POS_PLUGIN_URL', WP_PLUGIN_URL . '/' . WP_MI_PSW_POS_PLUGIN_NAME );
if ( ! defined( 'WP_MI_PSW_POS_PLUGIN_API_ENDPOINT' ) )
	define( 'WP_MI_PSW_POS_PLUGIN_API_ENDPOINT', 'https://www.mooninvoice.com' );
/**
 * Activate the plugin.
 */
register_activation_hook(__FILE__, 'psw_pos_check_version');
function psw_pos_check_version() {
    $php_version_required = '7.0';
    $wp_version_required  = '5.6.1';
    $wc_version_required  = '5.3.0';
    include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
    if ( version_compare( PHP_VERSION, $php_version_required, '<' ) ) {
        $error_message = __('This plugin can not be activated because it requires a PHP version greater than'.$php_version_required.'. Please update your PHP version before you activate it.');
        die($error_message);
    }
    
    if ( version_compare(get_bloginfo( 'version' ), $wp_version_required, '<') ) {
        $error_message = __('This plugin can not be activated because it requires a WordPress version greater than '.$wp_version_required.'. Please go to Dashboard -> Updates to get the latest version of WordPress. ');
        die($error_message);
    }
    
    if ( !is_plugin_active( 'woocommerce/woocommerce.php' ) ){
      $error_message = __('woocommerce plugin requires', 'woocommerce');
      die($error_message);
    }else{
        if ( ! class_exists( 'WooCommerce' ) ) return;
        if ( version_compare( WC_VERSION, $wc_version_required, '<' ) ) {
            $error_message = __('This plugin can not be activated because it requires a WooCommerce version greater than 3.3 . Please update your WooCommerce version before you activate it.');
            die($error_message);
        }
    }
    include WP_MI_PSW_POS_PLUGIN_PATH.'/public/mi_psw_pos_register_redirect.php';
    
    
}
include WP_MI_PSW_POS_PLUGIN_PATH.'/public/create-menu.php';
include WP_MI_PSW_POS_PLUGIN_PATH.'/public/auth_check.php';
include WP_MI_PSW_POS_PLUGIN_PATH."/inc/admin/mi_psw_pos_auth_callback.php";
include WP_MI_PSW_POS_PLUGIN_PATH."/inc/admin/psw_pos_sync_product.php";

add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'add_action_links' );
function add_action_links ( $actions ) {
   $mylinks = array(
      '<a href="' . admin_url( '/admin.php?page=psw-pos' ) . '">Settings</a>',
   );
   $actions = array_merge( $actions, $mylinks );
   return $actions;
}
/**
 * Deactivation hook.
 */
function psw_pos_pluginp_deactivate() {
    include WP_MI_PSW_POS_PLUGIN_PATH.'/public/mi_psw_pos_logout.php';
    delete_option('mi_psw_pos_auth_details');
    delete_option('psw_pos_allsyncproduct');
    delete_option('psw_pos_allsyncorder');
    delete_option('psw_pos_allsynccustomer');
    delete_option('psw_pos_singlesyncproduct');
    delete_option('psw_pos_singlesyncorder');
    delete_option('psw_pos_singlesynccustomer');
    delete_option('mi_pos_authorization_keys_data');
	delete_option('psw_pos_singlesync_company');
	delete_option('psw_pos_autosync_enable');
    
	flush_rewrite_rules();
}
register_deactivation_hook( __FILE__, 'psw_pos_pluginp_deactivate' );


add_filter( 'site_transient_update_plugins','psw_pos_push_update');
function psw_pos_push_update( $transient ){
 
	if ( empty( $transient->checked ) ) {
		return $transient;
	}
	$remote = wp_remote_get( 
		'https://www.mooninvoice.com/blog/wp-content/uploads/updater/info.json',
		array(
			'timeout' => 10,
			'headers' => array(
				'Accept' => 'application/json'
			)
		)
	);
	if( is_wp_error( $remote ) || 200 !== wp_remote_retrieve_response_code( $remote ) || empty( wp_remote_retrieve_body( $remote ) )){
		return $transient;	
	}
	$remote = json_decode( wp_remote_retrieve_body( $remote ) );
    //$plugin_data = get_plugin_data( __FILE__ );
    $plugin_data = get_plugin_data(WP_MI_PSW_POS_PLUGIN_PATH.'/products-sync-with-pos-moon-invoice.php' );
    if( $remote && version_compare( $plugin_data['Version'], $remote->version, '<' ) && version_compare( $remote->requires, get_bloginfo( 'version' ), '<' )	&& version_compare( $remote->requires_php, PHP_VERSION, '<' )) {
		$res = new stdClass();
        $res->name = $remote->name;
		$res->slug = $remote->slug;
        $res->author = $remote->author;
	    $res->author_profile = $remote->author_profile;
		$res->plugin = plugin_basename( __FILE__ ); // it could be just YOUR_PLUGIN_SLUG.php if your plugin doesn't have its own directory
		$res->new_version = $remote->version;
		$res->tested_up_to = $remote->tested;
        $res->tested = $remote->tested;
        $res->WC_requires_at_least = '5.3.0';
		$res->package = $remote->download_url;
        $res->download_link = $remote->download_url;
        $res->trunk = $remote->download_url;
        $res->last_updated = $remote->last_updated;
        $res->banners = array(
            'low' => $remote->banners->low,
            'high' => $remote->banners->high
        );
        $res->sections = array(
            'description' => $remote->sections->description,
            'installation' => $remote->sections->installation,
            'changelog' => $remote->sections->changelog
            // you can add your custom sections (tabs) here
        );


		$transient->response[ $res->plugin ] = $res;
	}
	return $transient;
}

add_filter( 'plugins_api', 'psw_pos_plugin_info', 20, 3);
/*
 * $res empty at this step
 * $action 'plugin_information'
 * $args stdClass Object ( [slug] => woocommerce [is_ssl] => [fields] => Array ( [banners] => 1 [reviews] => 1 [downloaded] => [active_installs] => 1 ) [per_page] => 24 [locale] => en_US )
 */
function psw_pos_plugin_info( $res, $action, $args ){

	// do nothing if this is not about getting plugin information
	if( 'plugin_information' !== $action ) {
		return $res;
	}

	// do nothing if it is not our plugin
	if( plugin_basename( __DIR__ ) !== $args->slug ) {
		return $res;
	}

	// info.json is the file with the actual plugin information on your server
	$remote = wp_remote_get( 
		'https://www.mooninvoice.com/blog/wp-content/uploads/updater/info.json', 
		array(
			'timeout' => 10,
			'headers' => array(
				'Accept' => 'application/json'
			) 
		)
	);
	// do nothing if we don't get the correct response from the server
	if( is_wp_error( $remote ) || 200 !== wp_remote_retrieve_response_code( $remote )|| empty( wp_remote_retrieve_body( $remote ) )) {
		return $res;	
	}

	$remote = json_decode( wp_remote_retrieve_body( $remote ) );
	
	$res = new stdClass();
	$res->name = $remote->name;
	$res->slug = $remote->slug;
	$res->author = $remote->author;
	$res->author_profile = $remote->author_profile;
	$res->version = $remote->version;
	$res->requires = $remote->requires;
	$res->requires_php = $remote->requires_php;
	$res->download_link = $remote->download_url;
	$res->trunk = $remote->download_url;
	$res->last_updated = $remote->last_updated;
	$res->sections = array(
		'description' => $remote->sections->description,
		'installation' => $remote->sections->installation,
		'changelog' => $remote->sections->changelog
		// you can add your custom sections (tabs) here
	);
	// in case you want the screenshots tab, use the following HTML format for its content:
	// <ol><li><a href="IMG_URL" target="_blank"><img src="IMG_URL" alt="CAPTION" /></a><p>CAPTION</p></li></ol>
	if( ! empty( $remote->sections->screenshots ) ) {
		$res->sections[ 'screenshots' ] = $remote->sections->screenshots;
	}

	$res->banners = array(
		'low' => $remote->banners->low,
		'high' => $remote->banners->high
	);
	return $res;

}
